import numpy as np
import math
import time

A = np.array([(1,2),(3,4)])
print("Matica A: \n", A)

B = np.array([[1,2],[3,4]])
print("Matica B: \n", B)

N = 5
vec_row = np.array([[1, 0, 0]])
print("Riadkovy vektor \n", vec_row)

vec_column = np.array([[1, 2, 3]]).T
print("Stlpcovy vektor \n", vec_column)

vec_row_2 = vec_column.T
print("Transponovany vektor \n", vec_row_2)

vec_linspace = np.linspace(0, 5, 10)
print("Vektor a linearnym rastom \n", vec_linspace)

vec_empty = np.array([])
print("Prazdny vektor \n", vec_empty)

## Specificka incializacia matic ##

mat_zero = np.zeros((2,3))
print("Nulova matica:\n", mat_zero)

mat_eye = np.eye(5)
print("Jednotkova matica:\n", mat_eye)

mat_rand = np.random.rand(3,5)
print("Matica nahodnych cisel:\n", mat_rand)

###
vec = np.array([4,5,6,7,8,9,10])
print("5 prvok vektora:",vec[4])

mat = np.array([[1, 2, 3], [4, 5, 6], [7, 8, 9]])
print("Pristup k elementu v matici (2,3):", mat[1][2])
print("Pristup k elementu v matici (1,3):", mat[0][2])


print("Prvy riadok matice ako riadkovy vektor:",mat[0,:])
print("Prvy stlpec matice ako riadkovy vektor:",mat[:,0])

print(mat[:, 2])
print("Submatica zacinajuca na 2,2:\n", mat[1:3, 1:3])
#Submatica zacinajuca od pociatku 2x2
print(mat[0:2,0:2])
print(mat[:2,:2])


print("Rozmery matice:", mat.shape)
print("Rozmery matice ", mat.shape[0])
print("Rozmery matice ", mat.shape[1])

print("Operacie s maticami a vektormi:\n")
vector_b = np.array([1, 2, 3, 4]).T
print(vector_b)
print(2*vector_b)
print(vector_b/2)

## umocnenie na 3
print(vector_b ** 3)

print("Vektorove operacie")
vector_c = np.array([1,2,3,4]).T

print(vector_b * vector_c)
print(vector_b / vector_c)
print(vector_b - vector_c)
print(np.log(vector_c))
print(np.round(np.log(vector_b)))

print("Skalarne operacie na vektore:\n")

print(np.sum(vector_b))
print(np.mean(vector_c))
print(np.var(vector_b))
print(np.std(vector_b))
print(np.min(vector_b), np.max(vector_b))

print("Operacie na matici, vystupom je vektor")

mat_x = np.array([[1,2,3],[4,5,6],[7,8,9]])
print(np.mean(mat_x, 0))
print("maximum s maice na osi 0 :", np.max(mat_x, 0))
print("maximum s maice na osi 1 :", np.max(mat_x, 1))
print(np.max(mat_x))
print(np.min(mat_x))

print("Sucin vektorov:\n")

print(vector_b * vector_c)
# vektorovy sucin
print(vector_b.T * vector_c)
# vektorovy sucin
print(vector_b * vector_c.T)
# skalarny sucin
print(vector_b @ vector_c.T)

print("Operacie na matici: \n")

mat_P = np.random.rand(3,2)
mat_H = np.random.rand(2,6)
vector_p = np.array([1,2,3]).T
vector_h = np.array([6,6])
print("\n", mat_P)
print("\n", mat_H)
print("\n", np.matmul(mat_P, mat_H))

print("\n", np.matmul(vector_h, mat_H))
print("\n", np.matmul(vector_p.T, mat_P))

print("Inverzna matica:\n", np.linalg.inv(np.random.rand(3, 3)))
print("Eigen values:\n", np.linalg.eig(np.random.rand(3, 3)))


print("Linearna algebra:\n")
V, D = np.linalg.eig(np.random.rand(3,3))
print("Eigen values is:\n",V)
print("Eigen matrix is\n",D)
print("\n\n")
U,S,V = np.linalg.svd(np.random.rand(3,3))
print("SVD single value decomposition:\n",U,"\n Eigen matrix:\n",S,"\n Eigen matrix:\n",V)

mat_K = np.random.rand(4,4)
print("\n",mat_K)

print("\n",np.linalg.det(mat_K))
print(np.sum(mat_K))
print(mat_K.reshape((8,2)))
print(mat_K.reshape((2,8)))

vector_g = np.array([1,2,3])
vector_w = np.array([4,5,6])

vector_q = np.concatenate((vector_g, vector_w),0)
print("\n",vector_q)
vector_u = np.array((vector_g, vector_w))
vector_u = np.squeeze(vector_u)
print(vector_u)

print(np.diag(mat_K))
print(np.repeat(A, 1, axis=0))

K = np.diag([1, 2, 3])
print(K)



for i in range(1, 7, 2):
    print (i)


for i in np.array([5, 13, -1]):
    if i > 10:
        print("Large than 10")
    elif i < 0:
        print("Negative value")
    else:
        print("Something else")

###

m = 50
n = 10

A = np.ones((m, n))

v = 2 * np.random.rand(1, n)
print(v)

for i in range(0, m):
    A[i, :] = A[i, :] - v
print(A)

# Implementácia s použitím maticových operácií
A = np.ones((m, n)) - np.repeat(v, m, axis=0)
print(A)

# Implementácia s použitím cyklov

B = np.zeros((m, n))
for i in range(1, m):
    for j in range(1, n):
        if A[i][j] > 0:
            B[i][j] = A[i][j]
print(B)

# Implementácia bez cyklov
B = np.zeros((m, n))
ind = np.where(A > 0)
B[ind] = A[ind]
print('B: ', B)


t = time.time()
x = np.empty((1, 1000000))
for i in range(1000000):
    x[0, i] = x[0, i - 1] + 5
print("čas: " + str(time.time() - t))

t = time.time()
x = np.zeros((1, 1000000))
for i in range(1000000):
    x[0, i] = x[0, i - 1] + 5
print("čas: " + str(time.time() - t))



def myfunction(x):
    a = np.array([-2, -1, 0, 1])
    y = a + x
    return y

def myotherfunction(a, b):
    y = a + b
    z = a - b
    return y, z

a = np.array([1, 2, 3, 4])
b = myfunction(2 * a)
print(b)
c, d = myotherfunction(a, b)
print(c, d)


